# get 1948 popular vote from 
# https://en.wikipedia.org/wiki/1948_United_States_presidential_election

set -e
set +x

data=1948-wikipedia.txt

echo 0 > tdem
echo 0 > trep
echo 0 > ttot
echo 0 > tedem
echo 0 > terep
echo 0 > tetot
echo 0 > nstate

rm -f statefile
touch statefile
state="NOSTATE"

cat $data | sed 'sX> X>\nXg' | grep -v 'https:' | grep -v cite_note | while read line ; do

#echo $line

if echo $line | egrep '^[A-Z]' > /dev/null ; then
	# new state or Total
	if test -s statefile ; then
		# print old state
		tstate=`cat statefile | head -1`
		#echo tstate $tstate
		statedata=`cat statefile | tail +2 | sed 'sX\nX Xg'`
 
# fgrep for exact match
state=`fgrep "$tstate" states.txt | head -1 | awk '{print $1}'`
set=`echo $statedata | awk '{print $1}'`
spd=`echo $statedata | awk '{print $2}' | sed 'sX,XXg'`
if test $spd = "-" ; then spd=0 ; fi
sed=`echo $statedata | awk '{print $4}'`
if test $sed = "-" ; then sed=0 ; fi
spr=`echo $statedata | awk '{print $5}' | sed 'sX,XXg'`
if test $spr = "-" ; then spr=0 ; fi
ser=`echo $statedata | awk '{print $7}'`
if test $ser = "-" ; then ser=0 ; fi
spt=`echo $statedata | awk '{print $(NF-1)}' | sed 'sX,XXg'`
#echo state $state set $set spt $spt
#echo spd $spd sed $sed
#echo spr $spr ser $ser

		if test `echo $state | awk '-F-' '{print NF}'` = 1 ; then
		# normal
			echo STATE $state $spd $spr $spt $sed $ser $set
		        otdem=`cat tdem`
		        otrep=`cat trep`
		        ottot=`cat ttot`
		        expr $otdem + $spd | cat > tdem
		        expr $otrep + $spr | cat > trep
		        expr $ottot + $spt | cat > ttot
		        onstate=`cat nstate`
		        expr $onstate + 1 > nstate
		else
		# ME
			echo DIST $state $spd $spr $spt $sed $ser $set
		fi
		        otedem=`cat tedem`
		        oterep=`cat terep`
		        otetot=`cat tetot`
		        expr $otedem + $sed | cat > tedem
		        expr $oterep + $ser | cat > terep
		        expr $otetot + $set | cat > tetot
		#echo TEST $state `cat nstate` d `cat tdem` r `cat trep` tot `cat ttot` d `cat tedem` r `cat terep` t `cat tetot`
	fi
	rm -f statefile
	touch statefile
	if echo "$line" | grep '^Total ' > /dev/null ; then 
		# end of file
		break ; 
	else
		echo "$line" >> statefile
	fi
else
	# another line in old state
	echo "$line" >> statefile
fi

done
echo TOTAL states `cat nstate` d `cat tdem` r `cat trep` t `cat ttot` d `cat tedem` r `cat terep` t `cat tetot` 

echo 'FEC  ' states 48 d 24179347 r 21991292 t 48793535 d 303 r 189 t 531

echo DONE getfec-1948.sh from $data

exit 0

