# get 1976 popular vote from 
# https://en.wikipedia.org/wiki/1976_United_States_presidential_election

#Alabama
#<https://en.wikipedia.org/wiki/1976_United_States_presidential_election_in_Alabama>
#        9       659,170         55.73   9       504,070         42.61   -
#-       -       -       1,481   0.13    -
#155,100         13.11   60.00   1,182,850       AL

set -e
set +x

data=1976-wikipedia.txt

echo 0 > tdem
echo 0 > trep
echo 0 > ttot
echo 0 > tedem
echo 0 > terep
echo 0 > tetot
echo 0 > nstate

rm -f statefile
touch statefile
state="NOSTATE"

cat $data | sed 'sX> X>\nXg' | grep -v 'https:' | while read line ; do

#echo $line

if echo $line | egrep '^[A-Z]|^/Maine' > /dev/null ; then
	# new state or Total
	if test -s statefile ; then
		# print old state
		tstate=`cat statefile | head -1`
		#echo tstate $tstate
		statedata=`cat statefile | tail +2 | sed 'sX\nX Xg'`
# handle Maine
case $tstate in
Maine*)
	state="ME"
	set=2
	sed=0
	ser=2
	spd=232279
	spr=236320
	spt=483208
;;
*Maine-1*)
	state="ME-1"
	set=1
	sed=0
	ser=1
	spd=123598
	spr=127019
	spt=250617
;;
*Maine-2*)
	state="ME-2"
	set=1
	sed=0
	ser=1
	spd=108681
	spr=109301
	spt=217982
;;
*)
 
# fgrep for exact match
state=`fgrep "$tstate" states.txt | head -1 | awk '{print $1}'`
set=`echo $statedata | awk '{print $1}'`
spd=`echo $statedata | awk '{print $2}' | sed 'sX,XXg'`
sed=`echo $statedata | awk '{print $4}'`
if test $sed = "-" ; then sed=0 ; fi
spr=`echo $statedata | awk '{print $5}' | sed 'sX,XXg'`
ser=`echo $statedata | awk '{print $7}'`
if test $ser = "-" ; then ser=0 ; fi
spt=`echo $statedata | awk '{print $17}' | sed 'sX,XXg'`
#echo state $state set $set spt $spt
#echo spd $spd sed $sed
#echo spr $spr ser $ser
;;
esac
		# handle ME districts
		if test "$state" ; then : ; else state="$tstate" ; fi
#		set=`expr $sed + $ser`
		if test `echo $state | awk '-F-' '{print NF}'` = 1 ; then
		# normal
			echo STATE $state $spd $spr $spt $sed $ser $set
		        otdem=`cat tdem`
		        otrep=`cat trep`
		        ottot=`cat ttot`
		        expr $otdem + $spd | cat > tdem
		        expr $otrep + $spr | cat > trep
		        expr $ottot + $spt | cat > ttot
		        onstate=`cat nstate`
		        expr $onstate + 1 > nstate
		else
		# ME
			echo DIST $state $spd $spr $spt $sed $ser $set
		fi
		        otedem=`cat tedem`
		        oterep=`cat terep`
		        otetot=`cat tetot`
		        expr $otedem + $sed | cat > tedem
		        expr $oterep + $ser | cat > terep
		        expr $otetot + $set | cat > tetot
		#echo TEST $state `cat nstate` d `cat tdem` r `cat trep` tot `cat ttot` d `cat tedem` r `cat terep` t `cat tetot`
	fi
	rm -f statefile
	touch statefile
	if echo "$line" | grep '^Total ' > /dev/null ; then 
		# end of file
		break ; 
	else
		echo "$line" >> statefile
	fi
else
	# another line in old state
	echo "$line" >> statefile
fi

done
echo TOTAL states `cat nstate` d `cat tdem` r `cat trep` t `cat ttot` d `cat tedem` r `cat terep` t `cat tetot` 

echo 'FEC  ' states 51 d 40831881 r 39148634 t 81531584 d 297 r 240 t 538

echo DONE getfec-1976.sh from $data

exit 0

