# get 1992 popular vote from 
# https://en.wikipedia.org/wiki/1992_United_States_presidential_election

set -e
set +x

data=1992-wikipedia.txt

echo 0 > tdem
echo 0 > trep
echo 0 > ttot
echo 0 > tedem
echo 0 > terep
echo 0 > tetot
echo 0 > nstate

rm -f statefile
touch statefile
state="NOSTATE"

cat $data | sed 'sX> X>\nXg' | grep -v 'https:' | while read line ; do

#echo $line

if echo $line | egrep '^[A-Z]|^/Maine|^/Nebraska' > /dev/null ; then
	# new state or Total
	if test -s statefile ; then
		# print old state
		tstate=`cat statefile | head -1`
		#echo tstate $tstate
		statedata=`cat statefile | tail +2 | sed 'sX\nX Xg'`
# handle Maine/Nebraska
case $tstate in
Maine*)
	state="ME"
	set=2
	sed=2
	ser=0
	spd=263420 
	spr=206504
	spt=679499
;;
*Maine-1*)
	state="ME-1"
	set=1
	sed=1
	ser=0
	spd=145191
	spr=115697
	spt=363716
;;
*Maine-2*)
	state="ME-2"
	set=1
	sed=1
	ser=0
	spd=118229
	spr=90807
	spt=313028
;;
Nebraska*)
	state="NE"
	set=2
	sed=0
	ser=2
	spd=217344
	spr=344346
	spt=739283 
;;
*Nebraska-1*)
	state="NE-1"
	set=1
	sed=0
	ser=1
	spd=80696
	spr=107081
	spt=247751
;;
*Nebraska-2*)
	state="NE-2"
	set=1
	sed=0
	ser=1
	spd=78701
	spr=115255
	spt=242613
;;
*Nebraska-3*)
	state="NE-3"
	set=1
	sed=0
	ser=1
	spd=57467
	spr=121342
	spt=224282
;;
*)
 
# fgrep for exact match
state=`fgrep "$tstate" states.txt | head -1 | awk '{print $1}'`
set=`echo $statedata | awk '{print $1}'`
spd=`echo $statedata | awk '{print $2}' | sed 'sX,XXg'`
sed=`echo $statedata | awk '{print $4}'`
if test `echo $sed | wc -c` -gt 3 ; then sed=0 ; fi
spr=`echo $statedata | awk '{print $5}' | sed 'sX,XXg'`
ser=`echo $statedata | awk '{print $7}'`
if test `echo $ser | wc -c` -gt 3 ; then ser=0 ; fi
spt=`echo $statedata | awk '{print $(NF-1)}' | sed 'sX,XXg'`
#echo state $state set $set spt $spt
#echo spd $spd sed $sed
#echo spr $spr ser $ser
;;
esac
		# handle ME districts
		if test "$state" ; then : ; else state="$tstate" ; fi
		if test `echo $state | awk '-F-' '{print NF}'` = 1 ; then
		# normal
			echo STATE $state $spd $spr $spt $sed $ser $set
		        otdem=`cat tdem`
		        otrep=`cat trep`
		        ottot=`cat ttot`
		        expr $otdem + $spd | cat > tdem
		        expr $otrep + $spr | cat > trep
		        expr $ottot + $spt | cat > ttot
		        onstate=`cat nstate`
		        expr $onstate + 1 > nstate
		else
		# ME
			echo DIST $state $spd $spr $spt $sed $ser $set
		fi
		        otedem=`cat tedem`
		        oterep=`cat terep`
		        otetot=`cat tetot`
		        expr $otedem + $sed | cat > tedem
		        expr $oterep + $ser | cat > terep
		        expr $otetot + $set | cat > tetot
		#echo TEST $state `cat nstate` d `cat tdem` r `cat trep` tot `cat ttot` d `cat tedem` r `cat terep` t `cat tetot`
	fi
	rm -f statefile
	touch statefile
	if echo "$line" | grep '^Total ' > /dev/null ; then 
		# end of file
		break ; 
	else
		echo "$line" >> statefile
	fi
else
	# another line in old state
	echo "$line" >> statefile
fi

done


echo TOTAL states `cat nstate` d `cat tdem` r `cat trep` t `cat ttot` d `cat tedem` r `cat terep` t `cat tetot`

echo 'FEC  ' states 51 d 44909889 r 39104545 t 104426659 d 370 r 168 t 538

exit

echo DONE getfec-1992.sh from $data
exit 0

