# get 2004 popular vote from 
# https://www.fec.gov/documents/1670/tables2004.xls sheet 3

set -e
set +x

data=2004tables.csv

echo 0 > tdem
echo 0 > trep
echo 0 > ttot
echo 0 > tedem
echo 0 > terep
echo 0 > tetot
echo 0 > nstate

# sed for 2004 OK which had exactly 0 third party votes, not quoted by FEC

cat $data | sed 'sX,0,X,"0",X' | awk '-F"' '{if (NF == 9) print $0}' | grep -v Total | while read line ; do

#echo $line

state=`echo $line | awk '-F,' '{print $1}'`

spd=`echo $line | awk '-F"' '{print $4}' | sed 'sX,XXg'`
spr=`echo $line | awk '-F"' '{print $2}' | sed 'sX,XXg'`
spt=`echo $line | awk '-F"' '{print $8}' | sed 'sX,XXg'`

# data has fields footnoted with *, e.g. 3**
sed=`echo $line | awk '-F,' '{print $3}' | sed 'sX\*XXg'`
ser=`echo $line | awk '-F,' '{print $2}' | sed 'sX\*XXg'`
if test "$sed" ; then : ; else sed=0 ; fi
if test "$ser" ; then : ; else ser=0 ; fi
# at large
if echo $state | egrep 'ME' > /dev/null ; then
        sed=2 
        ser=0
fi          
if echo $state | egrep 'NE' > /dev/null ; then
        sed=0
        ser=2
fi
set=`expr $sed + $ser`

echo STATE $state $spd $spr $spt $sed $ser $set

        otdem=`cat tdem`
        otrep=`cat trep`
        ottot=`cat ttot`
        otedem=`cat tedem`
        oterep=`cat terep`
        otetot=`cat tetot`
        onstate=`cat nstate`
        expr $otdem + $spd | cat > tdem
        expr $otrep + $spr | cat > trep
        expr $ottot + $spt | cat > ttot
        expr $otedem + $sed | cat > tedem
        expr $oterep + $ser | cat > terep
        expr $otetot + $set | cat > tetot
        expr $onstate + 1 | cat > nstate
	#echo TEST $state `cat nstate` d `cat tdem` r `cat trep` tot `cat ttot`

done

echo DIST ME-1 211703 165824 384392 1 0 1
echo DIST ME-2 185139 164377 356356 1 0 1
 
echo DIST NE-1 96314 164377 269771 0 1 1
echo DIST NE-2 97858 153041 254032 0 1 1
echo DIST NE-3 60156 189885 253452 0 1 1

        otedem=`cat tedem`
        oterep=`cat terep`
        otetot=`cat tetot`
        expr $otedem + 2 | cat > tedem
        expr $oterep + 3 | cat > terep
        expr $otetot + 5 | cat > tetot

echo TOTAL states `cat nstate` d `cat tdem` r `cat trep` t `cat ttot` d `cat tedem` r `cat terep` t `cat tetot`

echo 'FEC  ' states 51 d 59028444 r 62040610 t 122295345 d 251 r 286 t 538

echo DONE getfec-2004.sh from $data
exit 0

