# get 2020 popular vote from 
# https://en.wikipedia.org/wiki/2020_United_States_presidential_election

#N.Y.
#<https://en.wikipedia.org/wiki/2020_United_States_presidential_election_in_New_York>^[q]
#<#cite_note-341>        5,230,985       60.86%  29      3,244,798       37.75%
#\342\200\223    60,234
#0.70%   \342\200\223    32,753  0.38%   \342\200\223    26,056  0.30%   \342\200\223    1,986,187       23.11%  0.62%
#8,594,826

#1 # N.Y.
#1 # <https://en.wikipedia.org/wiki/2020_United_States_presidential_election_in_New_York>^[q]
#1 # <#cite_note-341>        5,230,985       60.86
#                            D
#  %
#2  29      3,244,798       37.75
#           R
#  %
#3 # \342\200\223    60,234
#                    L
#3 # 0.70
# %
#4   \342\200\223    32,753  0.38
#                    G
# %
#5   \342\200\223    26,056  0.30
#                    Other
# %
#6   \342\200\223    1,986,187       23.11
# %
#                    Margin
#7 0.62
#  Swing
# %
#8 # 8,594,826
#    Total

set -e
set +x

data=2020-wikipedia.txt

echo 0 > tdem
echo 0 > trep
echo 0 > ttot
echo 0 > tedem
echo 0 > terep
echo 0 > tetot
echo 0 > nstate

rm -f statefile
touch statefile
state="NOSTATE"

cat $data | sed 'sX> X>\nXg' | grep -v 'https:' | while read line ; do

#echo $line

if echo $line | grep '^[A-Z]' > /dev/null ; then
	# new state or Total
	if test -s statefile ; then
		# print old state
		statedata=`cat statefile | sed 'sX\nX Xg'`
		pctNF=`echo $statedata | awk '-F%' '{print NF}'`
		pct1=`echo $statedata | awk '-F%' '{print $1}'`
		pct2=`echo $statedata | awk '-F%' '{print $2}'`
		pct3=`echo $statedata | awk '-F%' '{print $3}'`
		pct4=`echo $statedata | awk '-F%' '{print $4}'`
		pct5=`echo $statedata | awk '-F%' '{print $5}'`
		pct6=`echo $statedata | awk '-F%' '{print $6}'`
		pct7=`echo $statedata | awk '-F%' '{print $7}'`
		pct8=`echo $statedata | awk '-F%' '{print $8}'`
		tstate=`echo $pct1 | awk '{print $1}'`
		# fgrep for exact match
		state=`fgrep "$tstate" states.txt | head -1 | awk '{print $1}'`
		# handle ME/NE districts
		if test "$state" ; then : ; else state="$tstate" ; fi
		spd=`echo $pct1 | awk '{print $(NF-1)}' | sed 'sX,XXg'`
		sed=`echo $pct2 | awk '{print $1}'`
		if test `echo $sed | wc -c` -gt 3 ; then sed=0 ; fi
		echo $state D $spd $sed
		spr=`echo $pct2 | awk '{print $(NF-1)}' | sed 'sX,XXg'`
		ser=`echo $pct3 | awk '{print $1}'`
		if test `echo $ser | wc -c` -gt 3 ; then ser=0 ; fi
		echo $state R $spr $ser
		set=`expr $sed + $ser`
		echo $state L `echo $pct3 | awk '{print $(NF-1)}' | sed 'sX,XXg'`
		case $pctNF in
		6)
		spt=`echo $pct6 | awk '{print $(NF)}' | sed 'sX,XXg'`
		echo $state T $spt $set
		;;
		7)
		if test "$state" = "KS" ; then
		echo $state G 669
		else
		echo $state O `echo $pct4 | awk '{print $(NF-1)}' | sed 'sX,XXg'`
		fi
		spt=`echo $pct7 | awk '{print $(NF)}' | sed 'sX,XXg'`
		echo $state T $spt $set
		;;
		8)
		echo $state G `echo $pct4 | awk '{print $(NF-1)}' | sed 'sX,XXg'`
		echo $state O `echo $pct5 | awk '{print $(NF-1)}' | sed 'sX,XXg'`
		spt=`echo $pct8 | awk '{print $(NF)}' | sed 'sX,XXg'`
		echo $state T $spt $set
		;;
		*)
			echo BAD pctNF $pctNF
			exit 99
		;;
		esac
		if test `echo $state | awk '-F-' '{print NF}'` = 1 ; then
		# normal
			echo STATE $state $spd $spr $spt $sed $ser $set
		        otdem=`cat tdem`
		        otrep=`cat trep`
		        ottot=`cat ttot`
		        expr $otdem + $spd | cat > tdem
		        expr $otrep + $spr | cat > trep
		        expr $ottot + $spt | cat > ttot
		        onstate=`cat nstate`
		        expr $onstate + 1 > nstate
		else
		# ME/NE
			echo DIST $state $spd $spr $spt $sed $ser $set
		fi
		        otedem=`cat tedem`
		        oterep=`cat terep`
		        otetot=`cat tetot`
		        expr $otedem + $sed | cat > tedem
		        expr $oterep + $ser | cat > terep
		        expr $otetot + $set | cat > tetot
		#echo TEST $state `cat nstate` d `cat tdem` r `cat trep` tot `cat ttot` d `cat tedem` r `cat terep` t `cat tetot`
	fi
	rm -f statefile
	touch statefile
	if echo "$line" | grep '^Total ' > /dev/null ; then 
		# end of file
		break ; 
	else
		echo "$line" >> statefile
	fi
else
	# another line in old state
	echo "$line" >> statefile
fi

done
echo TOTAL states `cat nstate` d `cat tdem` r `cat trep` t `cat ttot` d `cat tedem` r `cat terep` t `cat tetot` 

echo 'FEC  ' states 51 d 81268924 r 74216154 t 158383403 d 306 r 232 t 538

echo DONE getfec-2020.sh from $data

exit 0

