set -e
set +x

# compute state ev margins to flip electoral vote result

# $1 data file format

# STATE AL 849624 1441170 2323282 0 9 9
# DIST ME-1 266376 164045 443112 1 0 1
# FEC   states 51 d 81268924 r 74216154 t 158383403 d 306 r 232 t 538

data=$1

tdev=`cat $data | grep '^FEC' | awk '{print $11}'`
trev=`cat $data | grep '^FEC' | awk '{print $13}'`
ttev=`cat $data | grep '^FEC' | awk '{print $15}'`
thev=`expr $ttev / 2`
thev1=`expr $thev + 1`

#echo tdev $tdev rdev $rdev ttev $ttev thev $thev
echo

if test $tdev -le $thev ; then
	dneed=`expr $thev1 \- $tdev | cat`
	rneed=0
	echo compute flip from Rep $trev to Dem $tdev dneed $dneed
else
	rneed=`expr $tdev \- $thev | cat`
	dneed=0
	echo compute flip to Rep $trev from Dem $tdev rneed $rneed
fi

cat $1 | egrep 'STATE|DIST' | awk '{print $2}' | sort -u > statelist

#initialize
dpopularvote=0
rpopularvote=0
delectoralvote=0
relectoralvote=0
nstates=0
ndistricts=0

for state in `cat statelist` ; do

	nstates=`expr $nstates + 1 | cat`
	srvote=0
	sdvote=0
	sovote=0
	stvote=0
	cat $data | egrep 'STATE|DIST' | grep " $state " | while read xstate state dvote rvote tvote dev rev tev ; do
		if test "$rvote" ; then : ; else rvote=0 ; fi
		if test "$dvote" ; then : ; else dvote=0 ; fi
		ovote=`echo $dvote $rvote $tvote | awk '{print $3 - $1 - $2}'` 

if echo $state | egrep 'ME|NB' > /dev/null ; then 
	# special case ME/NB
	if echo $state | egrep '[A-Z]-' > /dev/null ; then
		# district has 1 ev
		mev=1
	else
		# state has 2 ev
		mev=2
	fi
else
	mev=$tev
fi

if test $dneed -gt 0 ; then
if test $dvote -le $rvote ; then
	margin2=`echo $dvote $rvote | awk '{print int((1 + $2 - $1)/2)}'`
	marginev=`expr $margin2 / $mev`
	echo $margin2 $mev $marginev DMARGIN2 $state $district $dvote $rvote $ovote $tvote 	
	margin1=`echo $dvote $rvote | awk '{print int(($2 - $1))}'`
	marginev=`expr $margin1 / $mev`
	if test $ovote -gt $margin1 ; then
	echo $margin1 $mev $marginev DMARGIN3 $state $district $dvote $rvote $ovote $tvote
	fi
fi
fi

if test $rneed -gt 0 ; then
if test $rvote -le $dvote ; then
	margin2=`echo $dvote $rvote | awk '{print int((1 + $1 - $2)/2)}'`
	marginev=`expr $margin2 / $mev`
	echo $margin2 $mev $marginev RMARGIN2 $state $district $dvote $rvote $ovote $tvote    
	margin1=`echo $dvote $rvote | awk '{print int(($1 - $2))}'`
	marginev=`expr $margin1 / $mev`
	if test $ovote -gt $margin1 ; then
	echo $margin1 $mev $marginev RMARGIN3 $state $district $dvote $rvote $ovote $tvote
	fi
fi
fi

done

done

echo DONE state-margins.sh $data

exit
